/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
# include <vector>
# include <iostream>
# include <algorithm>

using namespace std;

# include "StringUtils.h"
# include "LinkedList.h"
# include "IOUtils.h"
# include "ResidueCode.h"
# include "ReadPdb.h"
# include "ReadPrm.h"
# include "PrintPdb.h"
# include "Structures.h"

void ReadPrmFile(string PrmFile, vector<AtomStruct> &TempCharmmAtoms)
{
	string line;
	vector<string> str;
	AtomStruct CharmmAtom;
	cout <<"In ReadPrmFile"<<endl;
	fstream File;
	OpenFile(PrmFile, File, "PrmFile");
	//cout <<"Opened file "<<PrmFile<<endl;
	getline(File, line);
	while (true)
	{
		//cout <<line<<endl;
		if (File.eof()) break;
		if (line.substr(0,9)=="NONBONDED")
		{
			while (true)
			{
				if (File.eof()) break;
				if (line.substr(0,5)=="HBOND") break;
				Trim(line);
				DeleteStartingAt(line, "!");
				if (line.substr(0,1)!="!" && line!="" && line.substr(0,5)!="cutnb" && line.substr(0,5)!="CUTNB" && line.substr(0,9)!="NONBONDED")
				{
					DeleteStartingAt(line, "!");
					Tokenize2(line, " ", str);
					if (str.size()>3)
					{
						//cout <<"After Tokenize2"<<endl;
						//CharmmAtom.CharmmAtomName=line.substr(0,4);
						CharmmAtom.CharmmAtomName=str[0];
						//cout <<line<<endl;
						//cout <<"ERROR: Need to uncomment next line"<<endl;
						//exit(EXIT_FAILURE);
                                                //CharmmAtom.epsilon=-StrToFloat(str[2]);
						CharmmAtom.vdw=StrToFloat(str[3]);
                                                //cout <<"epsilon= "<<CharmmAtom.epsilon<<endl;
						//cout <<"vdw= "<<CharmmAtom.vdw<<endl;
						if (str.size()>6)
						{
							CharmmAtom.epsilon14=-StrToFloat(str[5]);
							//cout <<"epsilon14= "<<CharmmAtom.epsilon14<<endl;
							CharmmAtom.vdw14=StrToFloat(str[6]);
							//cout <<"vdw14= "<<CharmmAtom.vdw14<<endl;
						}
						Trim(CharmmAtom.CharmmAtomName);
						TempCharmmAtoms.push_back(CharmmAtom);
					}
				}
				getline(File, line);
			}
		}
		getline(File, line);
	}
	File.close();
}
