/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _ReadTrr_included_
#define _ReadTrr_included_

bool lineToTrrInfo(string line, Real &x, Real &y, Real &z)
{
	string sub;
	size_t begin, end, xPos;

	begin=line.find("{");
	end=line.find("}");
	xPos=line.find(" x");
        
	if (xPos!=string::npos && begin!=string::npos && end!=string::npos)
	{
		sub=line.substr(begin+1, end-begin);
		x=StrToReal(GetWord2(sub, 1))*10.0;
		y=StrToReal(GetWord2(sub, 2))*10.0;
		z=StrToReal(GetWord2(sub, 3))*10.0;
		return true;
	}
	return false;
}

void ReadTrr(string trrFile, vector<AtomStruct> &Atoms)
{
	fstream file;
	bool coordLine;
	string line;
	int count=0;
	Real x, y, z;

	OpenFile(trrFile, file, "trr file");

	getline(file, line);

	while (true)
	{
		if (file.eof()) break;
		coordLine=lineToTrrInfo(line, x, y, z);
		if (coordLine)
		{
			Atoms[count].x=x;
			Atoms[count].y=y;
			Atoms[count].z=z;
			count++;
		}
		getline(file, line);
	}
}



#endif
